

BEGIN{


	#  
        FileCount=0;
        OldDirCount=0
        NewDirCount=0
        OldDirExist=0;
        NomFforCp=0;
        NomFforMv=0;
        NomFforCporLn=0;
        SizeFforCp=0;
        SizeFforMv=0;

        copyNew="copy-new.bat"; #  
	ROtxt="r-o.tmp";


        #     
        FromDir=ENVIRON["FromDir"];
        ToDir=ENVIRON["ToDir"];
        ArxivDir=ENVIRON["ArxivDir"];

        scriptname=ENVIRON["scriptname"];


	#  ,        ,    
        gsub(/\"/,"",FromDir);
        gsub(/\"/,"",ToDir);
        gsub(/\"/,"",ArxivDir);

        gsub(/\\\\/,"\\",FromDir);
        gsub(/\\\\/,"\\",ToDir);
        gsub(/\\\\/,"\\",ArxivDir);

        sub(/\\*[ \t]*$/,"",FromDir); FromDir=FromDir "\\"
        sub(/\\*[ \t]*$/,"",ToDir); ToDir=ToDir "\\"

        sub(/\\*[ \t]*$/,"",ArxivDir); ArxivDir=ToDir ArxivDir "\\"

        # print(lastToDir) #  

        #   .   .
        LFromDir=length(FromDir); 
        LToDir=length(ToDir);
        LArxivDir=length(ArxivDir);


        #    
        D=ENVIRON["tmpdate"];
        T=ENVIRON["tmptime"];

	
	#      
	gsub(/[ \"]*/,"",D);
	split(D,tmpA,".")
	Day=tmpA[1]; Ma=tmpA[2]; Ya=tmpA[3];

	#  
	gsub(/[ \"]*/,"",T);
	split(T,tmpA,":")
	Hou=""tmpA[1]; Min=tmpA[2];

	#     
	if (length(Hou) == 1 ) Hou="0" Hou;

	#        
	DandT=""Ya Ma Day Hou Min;

	#    
	ArxivNewDir=ArxivDir  DandT "\\";
        LArxivNewDir=length(ArxivNewDir)

        #  
	paranoiamod=0;
	if (1 == 0+ENVIRON["paranoiamod"]) paranoiamod=1;
                                    


}

#     
function PrintCp(A){ print(A) >copyNew }


function DoCp(A,B) { PrintCp("copy " "\""A "\"  \"" B "\"" ) } #  


#      
function ShortName(A){

	sub(/.*\\/,"",A);
	return A;
}

#   DTS
function SizeFromDTS(Dts) {

	sub(/.*-/,"",Dts)
	return (0+Dts);

}


#      
function PathName(A){

	return substr(A,1,length(A)-length(ShortName(A)));
	#!!!!!!!
}

#          
function UpDirName(A){

        sub(/\\$/,"",A);

	return substr(A,1,length(A)-length(ShortName(A)));
}


#       
function NewFromOldPath(A){

	return ( FromDir substr(A,LToDir+1) );

}

#       
function OldFromNewPath(A){

	return ( ToDir substr(A,LFromDir+1) );

}

#        
function ArxFromOldPath(A){

	return ( ArxivNewDir substr(A,LToDir+1) );
}


#    (  )
function ClearOldDir(A,   Np,AA){

	Np=NewFromOldPath(A);

	if (A in DirToDir) if ( !(Np in DirFromDir) ){
		
		AA=A; sub(/\\$/,"",AA);

        	if (AA in ROfile) PrintCp("attrib -R " "\"" AA "\"");
		
		PrintCp("rmdir /s/q " "\"" A "\"");
		delete DirToDir[A]
	}
}

#    ToDir
function MakeDir(A){

	if( !(A in DirToDir)){
		
		MakeDir(UpDirName(A)); # 

		PrintCp("mkdir " "\""A "\"")
		DirToDir[A]=2;
	}
}

#         
function SaveFile(A,  B,I){

	B=ArxFromOldPath(A) ;

	MakeDir(PathName(B));

	if (A in ROfile) PrintCp("attrib -R " "\"" A "\"");
	
	PrintCp("move "  "\"" A "\""  " " "\"" B "\"")


	I=Infa(B,AskDTSOld[A])


	if (I !=0 && I in FileFromInfa) 
	{ 
		print(I "\n" B "\n"FileFromInfa[I] "\n------")>"log.tmp"

 		HashColl[I]=1;

 	}

        if (I !=0) FileFromInfa[I]=B ;  #    
        
	delete AskDTSOld[A];

}

#    (    )
function CopyFile(A,   B,I,C){

	B=OldFromNewPath(A)

	I = Infa(A,AskDTS[A]);

	if ( (I != 0) && (I in FileFromInfa) && !paranoiamod ) {

                PrintCp("move "  "\"" FileFromInfa[I] "\""  " " "\"" B "\"")
                #PrintCp("::!!! "I)
		
		NomFforMv++; # -  
                SizeFforMv=SizeFforMv + SizeFromDTS(AskDTS[A]) ; #  

                delete FileFromInfa[I];

	}else{

                PrintCp("copy "  "\"" A "\""  " " "\"" B "\"")
                #PrintCp("attrib -R " "\"" B "\"")

                NomFforCp++; # -  
                SizeFforCp=SizeFforCp + SizeFromDTS(AskDTS[A]) ; #  
        }
        	


}


#        .
function Type(A ,  t ){

	sub(/.*\./,"",A);

	#      .
	if      (A ~ /^[jJ][pP][gG]$/ || A ~ /^[jJ][pP][eE][gG]$/) t="jpg"
	else if (A ~ /^[dD][jJ][vV]$/ || A ~ /^[dD][jJ][vV][uU]$/ ) t="djv"
	else if (A ~ /^3[gG][pP]$/ ) t="3gp"
	else if (A ~ /^[mM][pP]3$/ ) t="mp3"
	else if (A ~ /^[mM][pP]4$/ ) t="mp4"
	else if (A ~ /^[Zz][Ii][Pp]$/ ) t="zip"
	else if (A ~ /^[Zz]$/ )         t="z"
	else if (A ~ /^[Gg][Zz]$/ )     t="gz"
	else if (A ~ /^[Tt][Gg][Zz]$/ ) t="tgz"
	else if (A ~ /^[Pp][Dd][Ff]$/ ) t="pdf"
	else if (A ~ /^[Pp][Ff][Bb]$/ ) t="pfb"
	else if (A ~ /^[Tt][Tt][Ff]$/ ) t="ttf"
	else if (A ~ /^[Aa][Vv][Ii]$/ ) t="avi"
	else if (A ~ /^[Mm][Kk][Vv]$/ ) t="mkv"
	#
	else t=0;   #   

	return t ;	
}

#   
function Infa(F,DTS,      Size,T){


	Size= SizeFromDTS(DTS); #  

	if (Size <= 1024*3) return 0;
	
	T=Type(F)

	F=ShortName(F);


	if ( T == 0 && Size >= 1024*50 ) return (DTS"-"F)
	else        return (DTS"-"T)

}



#    dir
#   dir  :

#     G   .
#    : 19EE-9E1C
# 
#    G:\razarabotka\generatorzadach-old
# 
# 02.03.2014  13:23    <DIR>          .
# 02.03.2014  13:23    <DIR>          ..
# 31.01.2015  20:47               397 00main.bat
# 04.04.2012  16:55                45 ftp.txt
# 12.04.2013  10:23             36326 ast.awk
# ...
# 04.05.2014  20:35    <DIR>          files
# 19.04.2014  18:03    <DIR>          BFRN
# 31.01.2015  20:45            302924 gzd-lb.awk
# 19.04.2014  18:03             79261 main.txt
#              165        17810875 
# 
#    G:\razarabotka\generatorzadach-old\ru
# 
# 02.03.2014  13:24    <DIR>          .
# 02.03.2014  13:24    <DIR>          ..
# 31.01.2015  16:10                23 .bat
# 17.12.2013  17:20               233 a.ini
# 23.12.2013  13:16               707 xxx.ini
# 31.01.2015  16:11    <DIR>           
# 31.01.2015  16:12    <DIR>          
# 09.12.2014  10:46              6660 2541.ini
# 23.01.2015  11:55              1034 sampl-z.ini
# 31.01.2015  16:10    <DIR>          
# 31.01.2015  16:11    <DIR>          Test 
#               13           68065 
# 
#    G:\razarabotka\generatorzadach-old\ru\ 
# 
# 31.01.2015  16:11    <DIR>          .
# 31.01.2015  16:11    <DIR>          ..
# 31.01.2015  16:11    <DIR>              
# 31.01.2015  16:11    <DIR>             
# 31.01.2015  16:11    <DIR>             
#                0               0 
# 
# 



#     ,   
( !($0~/^[0-9]/) && $0~/[A-Z]:/)  {  
	
	match($0,/[A-Z]:.*$/) ;

	dir=substr($0,RSTART)  ;

        sub(/\\*[ \t]*$/,"",dir); dir=dir "\\"

        gsub(/%/,"%%",dir);

        # dir -     
 
         
	#  
	if (FromDir == substr(dir,1,LFromDir) ) {
		
		DirFromDir[dir]=1;

		NewDirList[++NewDirCount]=dir;

	}  #  
	else if ( (ToDir == substr(dir,1,LToDir)) && (ArxivDir != substr(dir,1,LArxivDir)) ) {

		DirToDir[dir]=1 ;

		OldDirList[++OldDirCount]=dir;
	}


}

#    ,    
($0~/^[0-9]/ && $3 != "<DIR>")  {

	Day=$1;
	Time=$2;
	Size=$3;
	#$1="";$2="";$3=""; 
	#$4="";

	#      ,       .
	sub(/^..................................../,"");
	Name=$0;

        gsub(/%/,"%%",Name); #    %  

	#  
	DTS=Day"-"Time"-"Size;

	#!!!!!!!!!!!!!!  !!!  .


	#  
	if (FromDir == substr(dir,1,LFromDir) ) {
	  
     		#FoolName=substr(dir Name , LFromDir+1); #   .  
		FoolName=dir Name ; #   	        

	        #     
	     	AskDTS[FoolName]     =DTS;
	     	

	     	#print(DTS, SizeFromDTS(DTS)); #  

	     	#AskShotName[FoolName]=ShortName(FoolName);
	     	#AskType[FoolName]    =Type(FoolName);

	     	FileList[++FileCount]=FoolName;  #  .    .


	}  #  
	else if ( (ToDir == substr(dir,1,LToDir)) && (ArxivDir != substr(dir,1,LArxivDir))) {

		OldDirExist=1;  #   .

	     	FileName=dir Name; #  

	        #     
                AskDTSOld[FileName]=DTS;


	        #       (   !!!!!!!!!!)
	        #      
	     	#DTSandShotNameToOld[DTS"-"ShortName(FileName)]=FileName; 
                
	     	#if (Type(FileName) != 0 ) DTSandTypeToOld[DTS"-"Type(FileName)]=FileName;

	}
}


{
        #  .      .
	LastLine=$3
}

END {

#     
while ( (getline line < ROtxt) >0) {

	ROfile[line]=1;

}


#      
print("Thinking...")


PrintCp("@echo on\nchcp 1251")

#    
PrintCp("if exist "ArxivNewDir " echo The Copy Already exist!! &&pause");
PrintCp("if exist "ArxivNewDir " exit");







#   

ScriptDir=PathName(scriptname);

delete AskDTS[ScriptDir copyNew];
delete AskDTS[ScriptDir ROtxt];


PrintCp(":::::::::")

#       
for (i in AskDTSOld) {

	Newi=NewFromOldPath(i)        	

	if      ( !(Newi in AskDTS) )            SaveFile(i)
	else if ( AskDTSOld[i] != AskDTS[Newi] ) SaveFile(i)
	else {
		delete AskDTSOld[i];
		delete AskDTS[Newi];
	}
}

#   

	HashConflict=0
	for (I in HashColl) {
		delete FileFromInfa[I]
		HashConflict=1
	}

	if (HashConflict)  print("\nWarning!!! Hash conflict! See log.tmp and use paranoiamod.") ;  ##   


PrintCp(":::::::::")

#    (    dir)
for (i = OldDirCount ; i >=1 ; i-- ) ClearOldDir(OldDirList[i])

PrintCp(":::::::::")


#    (   dir)
for (i = 1 ; i <= NewDirCount ;  i++ ) MakeDir(OldFromNewPath(NewDirList[i])); 

PrintCp(":::::::::")


#   
for(i=1 ; i<=FileCount ; i++){

	F=FileList[i];

	if (F in AskDTS) CopyFile(F);

}

#   
print( "\nCopy " NomFforCp " files with " (int(SizeFforCp / (1024*10.24)) /100) " M") ;
print( "Move inside arhiv " NomFforMv " files") ;
#print( "Move inside arhiv " NomFforMv " files with " (int(SizeFforMv / (1024*10.24)) /100) " M") ;
print( (int(LastLine / (1024*10.24)) /100) " M free space on "ToDir"\n");

PrintCp("pause");


#for ( i in DirToDir)   print("c"i)

}




