

BEGIN{

	#  
        FileCount=0;
        OldDirExist=0;
        NomFforCp=0;
        NomFforLn=0;
        NomFforCporLn=0;
        SizeFforCp=0;
        SizeFforCporLn=0;



        #     
        FromDir=ENVIRON["FromDir"];
        ToDir=ENVIRON["ToDir"];
        lastToDir=ENVIRON["lastToDir"];

	#  ,        ,    
        gsub(/\"/,"",FromDir);
        gsub(/\"/,"",ToDir);
        gsub(/\"/,"",lastToDir);

        gsub(/\\\\/,"\\",FromDir);
        gsub(/\\\\/,"\\",ToDir);
        gsub(/\\\\/,"\\",lastToDir);  

        sub(/\\*[ \t]*$/,"",FromDir); FromDir=FromDir "\\"
        sub(/\\*[ \t]*$/,"",ToDir); ToDir=ToDir "\\"
        sub(/\\*[ \t]*$/,"",lastToDir); lastToDir=lastToDir "\\"

        # print(lastToDir) #  

        #   .   .
        LFromDir=length(FromDir); 
        LToDir=length(ToDir);
        LlastToDir=length(lastToDir);  


        #    
        D=ENVIRON["tmpdate"];
        T=ENVIRON["tmptime"];

	
	#   
	gsub(/[ \"]*/,"",D);
	split(D,tmpA,".")
	Day=tmpA[1]; Ma=tmpA[2]; Ya=tmpA[3];


	gsub(/[ \"]*/,"",T);
	split(T,tmpA,":")
	Hou=""tmpA[1]; Min=tmpA[2];

	#     
	if (length(Hou) == 1 ) Hou="0" Hou;

	#        
	DandT=""Ya Ma Day Hou Min;

	#  , temp    . (    .)
	NewDir=ToDir "temp" DandT;
                                    

        #  
	paranoiamod=0;
	if (1 == 0+ENVIRON["paranoiamod"]) paranoiamod=1;
                                    
	useln=0;
	if (1 == 0+ENVIRON["useln"]) useln=1;



}

#    ,    
function PrintCp(A){ print(A) >"copy-new.bat" }
function PrintLn(A){ print(A) >"link-old.bat" }

function DoLn(A,B) { #   
	
	if(useln) {
		PrintLn("ln " "\""A "\"  \"" B "\"") 
	}
	else {
		PrintLn("mklink /h " "\""B "\"  \"" A "\"") 	
	}
}

function DoCp(A,B) { PrintCp("copy " "\""A "\"  \"" B "\"" ) } #  

function DoInCp(From, To , Old ) {  # ln  .      .

	PrintCp("fc /b " "\"" From  "\""  "  "  "\"" Old "\""    " > nul")

	PrintCp("if ERRORLEVEL 1 (")
	PrintCp("copy " "\"" From "\"  \"" To "\"")
	PrintCp(") ELSE (")

	if(useln) {

		PrintCp("attrib -R " "\""Old "\"")
		PrintCp("ln " "\""Old "\"  \"" To "\"") 
	}
	else {
		PrintCp("mklink /h " "\""To "\"  \"" Old "\"") 	
	}

	PrintCp(")")    
}




#      
function ShortName(A){

	sub(/.*\\/,"",A);
	return A;
}

#        .
function Type(A ,  t ){

	sub(/.*\./,"",A);

	#      .
	if      (A ~ /^[jJ][pP][gG]$/ || A ~ /^[jJ][pP][eE][gG]$/) t="jpg"
	else if (A ~ /^[dD][jJ][vV]$/ || A ~ /^[dD][jJ][vV][uU]$/ ) t="djv"
	else if (A ~ /^3[gG][pP]$/ ) t="3gp"
	else if (A ~ /^[mM][pP]3$/ ) t="mp3"
	else if (A ~ /^[mM][pP]4$/ ) t="mp4"
	else if (A ~ /^[Zz][Ii][Pp]$/ ) t="zip"
	else if (A ~ /^[Zz]$/ )         t="z"
	else if (A ~ /^[Gg][Zz]$/ )     t="gz"
	else if (A ~ /^[Tt][Gg][Zz]$/ ) t="tgz"
	else if (A ~ /^[Pp][Dd][Ff]$/ ) t="pdf"
	else if (A ~ /^[Pp][Ff][Bb]$/ ) t="pfb"
	else if (A ~ /^[Tt][Tt][Ff]$/ ) t="ttf"
	else if (A ~ /^[Aa][Vv][Ii]$/ ) t="avi"
	else if (A ~ /^[Mm][Kk][Vv]$/ ) t="mkv"
	else t=0;   #   

	return t ;	
}


#    dir
#   dir  :

#     G   .
#    : 19EE-9E1C
# 
#    G:\razarabotka\generatorzadach-old
# 
# 02.03.2014  13:23    <DIR>          .
# 02.03.2014  13:23    <DIR>          ..
# 31.01.2015  20:47               397 00main.bat
# 04.04.2012  16:55                45 ftp.txt
# 12.04.2013  10:23             36326 ast.awk
# ...
# 04.05.2014  20:35    <DIR>          files
# 19.04.2014  18:03    <DIR>          BFRN
# 31.01.2015  20:45            302924 gzd-lb.awk
# 19.04.2014  18:03             79261 main.txt
#              165        17810875 
# 
#    G:\razarabotka\generatorzadach-old\ru
# 
# 02.03.2014  13:24    <DIR>          .
# 02.03.2014  13:24    <DIR>          ..
# 31.01.2015  16:10                23 .bat
# 17.12.2013  17:20               233 a.ini
# 23.12.2013  13:16               707 xxx.ini
# 31.01.2015  16:11    <DIR>           
# 31.01.2015  16:12    <DIR>          
# 09.12.2014  10:46              6660 2541.ini
# 23.01.2015  11:55              1034 sampl-z.ini
# 31.01.2015  16:10    <DIR>          
# 31.01.2015  16:11    <DIR>          Test 
#               13           68065 
# 
#    G:\razarabotka\generatorzadach-old\ru\ 
# 
# 31.01.2015  16:11    <DIR>          .
# 31.01.2015  16:11    <DIR>          ..
# 31.01.2015  16:11    <DIR>              
# 31.01.2015  16:11    <DIR>             
# 31.01.2015  16:11    <DIR>             
#                0               0 
# 
# 



#     ,   
( !($0~/^[0-9]/) && $0~/[A-z]:/)  {  
	
	match($0,/[A-z]:.*$/) ;

	dir=substr($0,RSTART)  ;

        sub(/\\*[ \t]*$/,"",dir); dir=dir "\\"

        gsub(/%/,"%%",dir);

        # dir -     
 
}

#    ,    
($0~/^[0-9]/ && $3 != "<DIR>")  {

	Day=$1;
	Time=$2;
	Size=$3;
	#$1="";$2="";$3=""; 
	#$4="";

	#      ,       .
	sub(/^..................................../,"");
	Name=$0;

        gsub(/%/,"%%",Name); #    %  

	#  
	DTS=Day"-"Time"-"Size;

	#  
	if (FromDir == substr(dir,1,LFromDir) ) {
	  
     		FoolName=substr(dir Name , LFromDir+1); #   .  
	        
	        #     
	     	AskDTS[FoolName]     =DTS;
	     	AskShotName[FoolName]=ShortName(FoolName);
	     	AskType[FoolName]    =Type(FoolName);

	     	FileList[FileCount++]=FoolName;  #  .    .


	}  #  
	else if (lastToDir == substr(dir,1,LlastToDir) ) {

		OldDirExist=1;  #   .

	     	FileName=dir Name; #  

	        #     
                AskDTSOld[FileName]=DTS;

	        #     
	     	DTSandShotNameToOld[DTS"-"ShortName(FileName)]=FileName; 
                
	     	if (Type(FileName) != 0 ) DTSandTypeToOld[DTS"-"Type(FileName)]=FileName;
	}
}



END {
	
	#   
	#   ,   
	PrintCp("@echo on\nchcp 1251")
	PrintLn("@echo on\nchcp 1251")

	#   
	PrintCp("mkdir \"" NewDir "\"" );
	
	#     .
	PrintCp("xcopy /e /t \"" FromDir "*\"  \"" NewDir "\\\"");
        
        #      readOnly. - ln  readonly   .

	if (OldDirExist == 1 && useln ) PrintLn("attrib -R /S /D "  "\""lastToDir "*\"");  
	
	#	if (paranoiamod == 1 ) { PrintCp("attrib -R /S /D "  "\""lastToDir "*\""); }
	#	else                   { PrintLn("attrib -R /S /D "  "\""lastToDir "*\""); }
	#}

	# 
	#        .      .
	for (i=0 ; i in FileList ; i++ ){  

		Name=FileList[i];  #   
                                            
	        Dist= NewDir "\\" Name; #  .
                 
                ExpectOldPlace= lastToDir  Name; #   

                if (AskDTS[Name] == AskDTSOld[ExpectOldPlace]) { #   ,  ln

               	        DoLn(ExpectOldPlace,Dist);			
               	        
               	        NomFforLn++;  #  
                }
                else {	#  
                	#     
                        DandSh=AskDTS[Name]"-"AskShotName[Name];
                        DandT =AskDTS[Name]"-"AskType[Name];

                        Size=substr(AskDTS[Name],18); #  

                        if ( 0+Size >= 1024) {IsBig=1} else {IsBig=0} ; #   - .


                        #        .
                        if ( DandSh in DTSandShotNameToOld) {  #       (..  )
                        	OldPlace = DTSandShotNameToOld[DandSh] ;
                	}
                	else if (DandT in DTSandTypeToOld) {  #       . (.  )
                        	OldPlace = DTSandTypeToOld[DandT] ;
                	}
                        else {   
                	        OldPlace="";
                	}
                	#  OldPlace


                	if (OldPlace == "") { # ..   , 

                		DoCp(FromDir Name ,Dist);

                		NomFforCp++;        #  
                		SizeFforCp+=Size;

                		if (IsBig) {
                			 DTSandShotNameToOld[DandSh]=Dist;  #      
                			 if (Type(Name) != 0) DTSandTypeToOld[DandT]=Dist;  #         
                		}

                	}
                	else {                #     
                		if (IsBig) {
                			#  ,   ,  ln
                		        if (paranoiamod) {
                		        	DoInCp(FromDir Name,Dist,OldPlace) #  
		                	
		                		NomFforCporLn++;
		                		SizeFforCporLn+=Size;

                		        }
                		        else {
                		        	DoLn(OldPlace , Dist) #   
                		        	
                		        	NomFforLn++;
                		        }	 
                		}
                		else{			
                			DoCp(FromDir Name , Dist);	#  ,      .			
	        
	                		NomFforCp++;        #  
        	        		SizeFforCp+=Size;                		
                		}				
                	}
		}
	}


	#  "  "
	if (OldDirExist == 1 && useln) PrintLn("attrib +R /S /D "  "\"" lastToDir "*\"");

	PrintLn("attrib +R /S /D "  "\""NewDir "\\*\"");

	#    last  temp.
	if (OldDirExist == 1) PrintLn("ren " "\""lastToDir"\"" " "  substr(substr(lastToDir,LToDir+5),1,12) );

	PrintLn("ren " "\""NewDir "\""   " "  "last"substr(substr(NewDir,LToDir+5),1,12) )

	#      readOnly. 
	PrintLn("echo for /D %%%%a in (last*) do attrib -R /S /D %%%%a/* >"  "\""ToDir "ReadOnly-Off.bat\"")
	PrintLn("echo for /D %%%%a in (last*) do attrib +R /S /D %%%%a/* >"  "\""ToDir "ReadOnly-On.bat\"")

	#       .
	PrintCp("pause");
	PrintLn("pause");


	#       .
	S="Copy " NomFforCp " files with " (int(SizeFforCp /(1024*10.24))/100) " M, Link " NomFforLn " files";
	if (paranoiamod) S=S", Copy or link " NomFforCporLn " files with " (int(SizeFforCporLn/(1024*10.24))/100) " M";

	print(S);


} #   .


